/*
 Test for Allen Bradley's CRC calculation

 Part of VISUAL, a human machine interface and data acquisition program
 
 (C) Thomas Hergenhahn (thomas.hergenhahn@web.de) 2002.

 VISUAL is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 VISUAL is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Visual; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
*/
#include <stdio.h>
/*
    This is the example from AB's manual (ww.ab.com/manuals(cn/17706516.pdf):
*/

unsigned char ab_org[] = { 0x10, 0x2, 0x7, 0x11, 0x41, 0x0, 0x53, 0xb9,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x10, 0x03
};
// 6b 4c must come out

unsigned char ab2[] = { 0x2, 0x7, 0x11, 0x41, 0x0, 0x53, 0xb9,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00,
    0x03
};

unsigned char ab3[] = {
    2, 0, 0, 15, 0, 97, 0,
    162, 20, 7, 137, 255, 200, 0, 0, 3
};

//12,134, ok

unsigned char ab4[] = {
//16,
    2, 0, 0, 15, 0, 99, 0,
    162, 20, 7, 137, 255, 200, 0, 0,
//16,
    3
};
//,7,62, 73e

unsigned char ab[] = {
//16,
    2, 0, 0, 15, 0, 16,
//16,
    0, 162, 20, 7, 137, 255, 200, 0,
    0
//,16
    , 3
};
// ,162,187, a2bb


void ab_send(unsigned char *ab, int size)
{
    unsigned short sum, s2;
    int i, j;
    unsigned char *b1 = ab;
/*    
    sum = sum ^ 0x10;
    for (i=0;i<=7;i++) {
        if (sum & 0x1) {
	    sum = sum >>1;
	    sum = sum ^ 0xA001;
	} else {
	    sum = sum >>1;
	}
    }
    
    sum = sum ^ 0x02;
    
    for (i=0;i<=7;i++) {
        if (sum & 0x1) {
	    sum = sum >>1;
	    sum = sum ^ 0xA001;
	} else {
	    sum = sum >>1;
	}
    }		
*/
    sum = 0;
    for (j = 1; j < size; j++) {
	LOG2("I calc: %x.\n", sum);
	sum = sum ^ (b1[j]);
	LOG2("after xor data: %x.\n", sum);
	s2 = sum;
	for (i = 0; i <= 7; i++) {
	    if (sum & 0x1) {
		sum = sum >> 1;
		sum = sum ^ 0xA001;
	    } else
		sum = sum >> 1;
	    LOG2("loop: %x.\n", sum);
	}
    }
    sum = sum / 256 + 256 * (sum % 256);
    LOG2("I calc: %x.\n", sum);
}

int main()
{
    ab_send(ab, 16);
}
