/*
 A variable type for ACPLT/KS that is coupled to a trend manged by mod_trend.

 Part of VISUAL, a human machine interface and data acquisition program
 
 (C) Thomas Hergenhahn (thomas.hergenhahn@web.de) 2004.

 VISUAL is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 VISUAL is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Visual; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
*/


#include "ks/simpleserver.h"
#include "plclog.h"

#include "cellList.h"
#include "trendVar.h"
#include "lib0.h"

#define ThisModule "ACPLT/KS : "
extern int rfd;
/*
    KsDoubleVecValue * doubles_val = 
        new KsDoubleVecValue(10);
    for (size_t i = 0 ; i < doubles_val->size(); ++i) {
        (*doubles_val)[i] = i*i;
    }
    doubles_var->setValue(doubles_val);
*/    
    TrendVariable::TrendVariable(trendRecordInst * ent):KssSimpleVariable(
        cellN(ent->Cell), KsTime::now(), symbolName(ent->sheet,ent->Cell,symOnly).c_str()){
//	this->sheet=sheet;
	this->ent=ent;
	doubles_val = new KsDoubleVecValue(ent->numEntries);
//	cell * ce=sheets[sheet]->find(c);
//	if (ce->isFormula()) 
	lock();
    }
    
    KsValueHandle TrendVariable::getValue() const {
	    KsDoubleVecValue *doubles_val1 = new KsDoubleVecValue(ent->usedEntries);
	    KsValue *pVal = doubles_val1;
//	    KsValue *pVal;
//	    pVal = new KsDoubleVecValue(ent->numEntries);
	    for (int i=0; i<ent->usedEntries; i++) {
//	    for (int i=0; i<doubles_val1->size(); i++) {
//		int j=i;
		int j=(i+ent->nextEntry) % ent->usedEntries;
/*		
		if (tri->trendMem[j].time > from) {
		    sprintf(s1,"%d,%12.7f,%g\n",tri->trendMem[j].number, 
		    tri->trendMem[j].time,
		    tri->trendMem[j].v);	
#if debug > 0		
	    LOG4("%d,%12.7f,%g\n",tri->trendMem[j].number, 
		tri->trendMem[j].time,
*/		
		    (*doubles_val1)[i] = ent->trendMem[j].v;
//		    *((KsDoubleVecValue *)(pVal))[i] = ent->trendMem[j].v;		
//		    (*pVal)[i] = ent->trendMem[j].v;		
/*
#endif		
#if debug > 0	
	    int wr=
#endif	
		write(fd, s1, strlen(s1));
#if debug > 0
	    LOG3(ThisModule "write %d %d\n", i, wr);
	    FLUSH;
#endif	
*/
	    }
//	    setValue(doubles_val);
	    return KsValueHandle(pVal, KsOsNew);
    }
    
    
    KS_RESULT TrendVariable::setValue(const KsValueHandle &h) {
        LOG1("ACPLT/KS setValue(h)\n");
/*	    
        KsValue * tmp = h.getPtr();
        KsDoubleValue * pVal_x = 
	    PLT_DYNAMIC_PCAST(KsDoubleValue, tmp);
        if (pVal_x) {
	    double ddd=*pVal_x;
	    LOG2("%g\n",ddd);
	    setCell(sheet,c,ddd,soExternal);
	    return KS_ERR_OK;
	}
*/	
	return KS_ERR_OK;
    }
    
    KsTime TrendVariable::getTime() const
    {
	cell * ce=sheets[ent->sheet]->find(ent->Cell);
	if (ce->typeID() == tnTimeCell) {
	    return ((nTimeCell *) ce)->time;
	} else {
	    if (ce->typeID() == tfTimeCell) {
		return ((fTimeCell *) ce)->time;
	    }	
	}    
	return 0;
    }



/*
    Make a SimpleVar from each cell in sheet:
*/
void makeTrendVar(void *p, void * d)
{
    trendVarData * svd=(trendVarData*)d;
    KssSimpleDomain * dom=(KssSimpleDomain*)(svd->d);
    trendRecordInst *ent = (trendRecordInst *) p;
    TrendVariable *var =  new TrendVariable(ent);
    var->setState(KS_ST_GOOD);
    dom->addChild(var);
}
/*
    Changes:
    
    12/01/2003  put in a seperate file to speed up compilation
    12/01/2003  write support for numeric values
    11/10/2004  replace "../drivers/plclog" by "plclog"
*/
