/*
 test to load a configuration file.

 Part of VISUAL, a human machine interface and data acquisition program
 
 (C) Thomas Hergenhahn (thomas.hergenhahn@web.de) 2001.

 VISUAL is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 VISUAL is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Visual; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
*/
#include <iostream.h>
#include <fstream.h>
#include "lib0.h"

#include "vi_string.h"

#ifndef use_string_2
#else
#define getline readline
#define find index
#define erase del
#endif

string sheetdir, driverdir, driverlib, driverparms;

int main()
{
    string s;
    int i = 1, p;
    fstream f("visual.cfg", ios::in);
    cout << "after open" << endl;
  nextline:
    while (getline(f, s)) {
	cout << "line " << i << ": " << s << endl;
	i++;
	if (s.find("#") == 0)
	    goto nextline;
	if (s.find("sheets:") == 0) {
#ifndef use_string_2
	    sheetdir = noSpace(s.substr(7));
#else
	    sheetdir = noSpace(s.from(7));
#endif
	    cout << "found sheets directory: " << sheetdir << endl;

	    goto nextline;
	}

	if (s.find("driverpath:") == 0) {
#ifndef use_string_2
	    driverdir = noSpace(s.substr(11));
#else
	    driverdir = noSpace(s.from(11));
#endif
	    cout << "found driver directory: " << driverdir << endl;
	    goto nextline;
	}
	if (s.find("driver:") == 0) {
#ifndef use_string_2
	    driverlib = s.substr(7);
#else
	    driverlib = s.from(7);
#endif
	    do {
		p = driverlib.find(" ");
		if (p == 0)
		    driverlib.erase(0, 1);
	    } while (p == 0);
#ifndef use_string_2
	    driverparms = driverlib.substr(p + 1);
	    driverlib = driverlib.substr(0, p);
#else
	    driverparms = driverlib.after(p);
	    driverlib = driverlib.before(p);
#endif
	    cout << "found driver: lib: " << driverlib << endl;
	    cout << "found driver: info: " << driverparms << endl;
	    goto nextline;
	}

    }
    cout << "file ended" << endl;
    f.close();
}
