/*
 Implementation of a PLC driver for binary data exchange.

 Part of VISUAL, a human machine interface and data acquisition program
 
 (C) Thomas Hergenhahn (thomas.hergenhahn@web.de) 2001.

 VISUAL is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 VISUAL is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Visual; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
*/
#ifndef __bin_drv
#define __bin_drv

#define uc unsigned char

class binDriver:public PLCdrv {
public:
    binDriver();
    int readChars(uc *b, int tmo);
    int readSingle(uc *b, int tmo);
    void setShortValues(short * w, int count, int sheet, coord cell);
    void setFloatValues(float * w, int count, int sheet, coord cell);
};

#endif
/*
    Changes:
    
    23/12/2002 	created.
*/
