{$I-}
unit lib_Eth;
interface

{$packrecords 1}

type
  st4 = string[4];
  st12 = string[12];
  st16 = string[16];

  PEthernetAddr = ^EthernetAddr;
  EthernetAddr = Array[0..5] of Byte;

sockaddr_ll = record
    sll_family,
    sll_protocol: word;
    sll_ifindex: longint;
    sll_hatype: word;
    sll_pkttype: char;
    sll_halen: char;
    sll_addr: array [0..7] of char;
end;

const AF_PACKET = 17;
      PF_PACKET = AF_PACKET;
const Broadcast:EthernetAddr =($0ff,$ff,$ff,$ff,$ff,$ff);


type
  MACHeader    = RECORD { IEEE 802.3 header }
                        DestAddr   : EthernetAddr;
                        SourceAddr : EthernetAddr;
                        TypeLen    : Word;
                END;

  PARP_Header  = ^ARP_Header;
  ARP_Header  = record
    hwType,
    protType: word;
    hwAddrLen,   {// hw and prot addr len}
    ProtAddrLen: byte;
    opcode:word;
    srcEthAddr: EtherNetAddr;
    srcIPAddr:  longint;
    dstEthAddr: EtherNetAddr;
    dstIPAddr: longint;
  end;

  PIP_Header  = ^IP_Header;
  IP_Header = record
    hdrlen_ver     :byte;
    type_of_service: byte;
    length,
    identification,
    frags:          word;
{    unsigned        frags : 3; }
{    unsigned        fo    : 13; }
    ttl,
    proto:          byte;
    checksum:       word;
    source:         longint;
    destination:    longint;
end;

type

  PAnyPacket =^TAnyPacket;
  TAnyPacket = Record
     case integer of 0: (RawBytes:Array[00..1524] of Byte);
                     1: (MacH:  MACHeader; ARP: ARP_Header);
                     2: (MacH2: MACHeader; IP: IP_Header);
  end;

const t_ARP = $0806;
      t_IP  = $0800;

const ARP_REQUEST =$0100;
const ARP_REPLY   =$0200;

implementation

end.


