/*
 Implementation of a queue of strings.

 Part of VISUAL, a human machine interface and data acquisition program
 
 (C) Thomas Hergenhahn (thomas.hergenhahn@web.de) 2001.

 VISUAL is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 VISUAL is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Visual; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
*/

#include "queue.h"

#include "stdio.h"
#define ThisModule "queue    : "
#define debug 10

//    int queue:: put(string& st,int _PID) {
    int queue:: put(string& st) {
//	int rfd=0;
#if debug > 0
	LOG4("put w:%d r:%d %s \n",writePos,readPos, st.c_str());
	FLUSH;
#endif	

	int nWritePos=(writePos+1)%length;
	if (nWritePos == readPos) return -1; //capacity exhausted
	items[nWritePos] = st;
	writePos=nWritePos;
	
	return 0; // o.k.
	
    }
    
//    string queue:: nextElement(int _PID) {
    string queue:: nextElement() {
//	if (hasMoreElements(_PID)) {
	if (hasMoreElements()) {
	    readPos=(readPos+1)%length;
	    return items[readPos];
	} else return NULL;
    }
    
//    bool queue::hasMoreElements(int _PID) {
    bool queue::hasMoreElements() {
	int rfd=0;
#if debug > 0
	LOG3("hasMore w:%d r:%d \n", readPos, writePos);
	FLUSH;
#endif			    
	return (readPos!=writePos);
    }
/*
    Changes:
    11/08/2004 	fixed a typo.
*/
