void sendIfChanged(void *p, void *ab)
{
    cell *c = (cell *) p;
    if (c->getFlags() & ((abstr *) ab)->mask) {
	c->setFlags(c->getFlags() & ~((abstr *) ab)->mask);
	string s = cellName(c) + "=" + formatDouble(c->getVal(), 0,
						    2) + ":" +
	    formatDouble(c->getState(), 0, 0) + "\n";
	write(((abstr *) ab)->fd, s.c_str(), s.length());
    }
}

void sendValue(void *p, void *fd)
{
    cell *c = (cell *) p;
    string s = cellName(c->k) + "=" + formatDouble(c->getVal(), 0,
						   2) + ":" +
	formatDouble(c->getState(), 0, 0) + "\n";
    write((int) fd, s.c_str(), s.length());
}

void sendValues(int fd, int sheet)
{
    if (sheets[sheet] != NULL) {
	sheets[sheet]->forEach(sendValue, (void *) fd);
    }
    string s = "end of sheet\n";
    write(fd, s.c_str(), s.length());
}

void sendChanges(int fd, int sheet, int mask)
{
    abstr a;
    a.fd = fd;
    a.mask = mask;
    if (sheets[sheet] != NULL) {
	sheets[sheet]->forEach(sendIfChanged, (void *) &a);
    }
    string s = "end of sheet\n";
    write(fd, s.c_str(), s.length());
}
