/*
 ediCellList.h: Definitions of insert/delete functions for cellList.
 this is not in cellList, to keep minimum runtime code small. Could be 
 moved into a library for load on demand ?.

 Part of VISUAL, a human machine interface and data acquisition program
 
 (C) Thomas Hergenhahn (thomas.hergenhahn@web.de) 2001. 

 VISUAL is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 VISUAL is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Visual; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
*/
#ifndef _ediCellList_
#define _ediCellList_
#include "mytypes.h"
#include "cell.h"
#include "cellList.h"

#include "vi_string.h"

// this is what we cann pass to mark:

#define markFalse 0
#define markTrue 1
#define markToggle 2

class ediCellList:public cellList {
  public:
    void deleteCell(coord c);
    void createCell(coord c, string s, int sourceT);
    void insertLabel(coord c, string s);
    void insertLabelAndCFlags(coord c, string s, int& cFlags);
    void mark(coord c, int b);
    void withArea(int what, coord st, coord en, string fn, bool & valid);
    void copyCells(coord st, coord en, coord cur, bool doShift=true);
    void insertShiftedCell(coord c, string s, int sourceT, int sp, int ze);
};

#define srDelete 1
#define srMark 2
#define srSave 3
#define srAddTime 4

#endif				/* _ediCellList_ */
