/*
 Some global variable definitions.

 Part of VISUAL, a human machine interface and data acquisition program
 
 (C) Thomas Hergenhahn (thomas.hergenhahn@web.de) 2001. 

 VISUAL is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 VISUAL is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Visual; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
*/
#ifndef _globals_
#define _globals_
#include "mytypes.h"

extern int glMinutes;
extern int glSeconds;
extern int glUSeconds;
extern int glHours;
extern int glDay;
extern int glMonth;
extern int glYear;
extern int glDayOfWeek;
//extern int glHMIPage; //Active HMI page in the local viewer.
			// was intended to fetch additional data
			// when page xx is showed.
			// maybe this should not be used, because 
			// there may be more than one viewer
extern string projectPath;	// where we store spreadsheet contents,
				// driver transfer lists,...
extern int glHMIsheet;		// sheet used by HMIViewer
extern coord glHMImarked;	// cell used by HMIViewer
extern double glCPULoad;	// CPU Load caused by calculation and modules
extern void * trendMemList;	// List of trend data memory. Actually,
				// this is the DRI list for mod_trend, but it is not
				// necessary to make this dependent of mod_trend,
				// so it's declared VOID here.
				
#endif				/* _globals_ */
/*
    Changes:
    
    02/14/2003 	changed comment
    07/20/2003  added USeconds system var
*/
