/*
 Definitions of helper functions for messages in the spreadsheet viewer. 
 Maybe replaced by something else which allows to change language without
 recompilation.

 Part of VISUAL, a human machine interface and data acquisition program
 
 (C) Thomas Hergenhahn (thomas.hergenhahn@web.de) 2001. 

 VISUAL is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 VISUAL is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
*/
#ifndef __helpers
#define __helpers
#include "pString.h"

#include "vi_string.h"

#define scShGoto 122
#define scShLeer 123
#define scShText 124
#define scShZahl 125
#define scShForm 126
#define scShLastChange 127
#define scShError 128
#define scShFOR 129		// what we display in the upper left corner when
			// we show formulas instead of results
#define scShRES 130		// what we display in the upper left corner
			// we show results                      
#define scShSave 131		// hint to save the sheet
#define scShTitle 132		// sheet window title
#define scShPageNumber 133	//
#define scShAskCreate 134	//
#define scShNoArea 135		// no area choosen
#define scShNoSheet 136		// sheet no n doesn't exist
#define scShDelArea 137		// ask this before really deleting an area
#define scShClose 138		// ask this before closing the last view 
				// to a changed sheet

#define scOfSourcet 1111
#define scOfMath 2222
//
// Text fragment numbers for Menus:
//
#define scOfMenus 2300
#define scAbout scOfMenus+0
//
// Texts for I/O errors:
//
#define scOfIoErrors 3100

typedef string (*getLangString) (int );

extern getLangString scLang;

string sc(int sc);
string ioErrorText(int sc);
string extDateTimeString(time_t t);
string listTPN(pString &s, int decimals);

#endif //__helpers

/*
    Changes:
    02/12/2002	text for about box now provided by language module
    12/14/2002	adaptions for gcc 3.0.4
    02/23/2003	changed include <tvision/...> to "tvision/..."

*/
