/*
 Helper functions for messages in the spreadsheet viewer. Maybe replaced
 by something which allows to change language without recompilation.

 Part of VISUAL, a human machine interface and data acquisition program

 (C) Thomas Hergenhahn (thomas.hergenhahn@web.de) 2001. 

 VISUAL is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 VISUAL is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
*/
#define Uses_TRect
#define Uses_TStatusLine
#define Uses_TStatusDef
#define Uses_TStatusItem
#define Uses_TKeys
#define Uses_TMenuBar
#define Uses_TMenu
#define Uses_TSubMenu
#define Uses_TMenuItem
#define Uses_TDialog

#include "tvision/tv.h"
#include "shcommands.h"
#include "viewcommands.h"
#include "hcontext.h"


#include "cell.h"
#include "helpers.h"
#include "lib0.h"

#include "vi_string.h"

typedef void (*langInitProc)(void);

typedef TStatusLine * (*getLangStatus) (TRect);
extern getLangStatus LangStatus;
typedef TMenuBar * (*getLangMenu) (TRect);
extern getLangMenu LangMenu;

typedef TDialog * (*getLangDialog) ();
extern getLangDialog LangOptionsDialog;

extern "C" void initLanguage();

