/*
 list.h: Definitions of a basic list type.

 Part of VISUAL, a human machine interface and data acquisition program
 
 (C) Thomas Hergenhahn (thomas.hergenhahn@web.de) 2001.

 VISUAL is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 VISUAL is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Visual; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
*/
#ifndef _list_
#define _list_

#include "persist.h"

typedef void (*todo) (void *, void *);

class list:public base {
  public:
    int count, limit, delta;
//    void **items;
    base **items;
     list();
     ~list();
//    virtual int insert(void *item);
    virtual int insert(base *item);    
//    void atInsert(int index, void *item);
    void atInsert(int index, base *item);
    void error(int code, int) {
	exit(212 - code);
    } void setLimit(int aLimit);
    virtual bool search(void *key, int &index);
    virtual int compare(void *key1, void *key2);
    void forEach(todo t, void *arg) const;
//    int indexOf(void *item);
    int indexOf(base *item);
    void atRemove(int index);
//    void free(void *item);
    void free(base *item);    
};

#endif				/* _list_ */
/*
    Changes:
    
    05/13/2002  Sheet is now loaded using persistence mechanism. List is 
		therefore derived from base.
		Object Read & write functions return void now. 
		cout<<... replaced by printf(..
*/
