#ifndef __openSocket
#define __openSocket

#ifndef DONT_USE_GETHOSTBYNAME
#include <netdb.h>		// for gethostbyname
#endif


int openSocket(const int port, const char * peer) {
    int fd; //,res,opt;
    sockaddr_in addr;
    socklen_t addrlen;
    LOG1(ThisModule "enter OpenSocket");
    FLUSH;
    addr.sin_family = AF_INET;
    addr.sin_port =
	(((port) & 0xff) << 8) | (((port) & 0xff00) >> 8);
#ifndef DONT_USE_GETHOSTBYNAME
    hostent *he = gethostbyname(peer);
    memcpy(&addr.sin_addr, he->h_addr_list[0], sizeof(addr.sin_addr));
#else
    inet_aton(peer.c_str(), &addr.sin_addr);
#endif

    fd = socket(AF_INET, SOCK_STREAM, 0);
    LOG2(ThisModule "OpenSocket: socket is %d\n", fd);
    
    addrlen = sizeof(addr);
    if (connect(fd, (sockaddr *) & addr, addrlen)) {
	LOG2(ThisModule "Socket error: %s \n", strerror(errno));
	close(fd);
	fd = 0;
    } else {
	LOG2(ThisModule "Connected to host: %s \n", peer);
/*
	errno=0;
	opt=1;
	res=setsockopt(fd, SOL_SOCKET, SO_KEEPALIVE, &opt, 4);
	LOG3(ThisModule "setsockopt %s %d\n", strerror(errno),res);
*/	
    }	
    FLUSH;
    return fd;
}

#endif
/*
    Changes: 
    07/12/2003	moved openSocket to it's own file, because it can be reused in other TCP clients
*/
