/*
 Implements a type Manager and a bsic object that registers itself with
 the type Manager.

 Part of VISUAL, a human machine interface and data acquisition program

 Much of this code is stolen from the sources of the CommonC++ library.
 
 CommonC++ is Copyright (C) 1999-2001 Open Source Telecom Corporation.
 Daniel Silverstone designed original Common C++ classes (persistence
	engine, math libs, etc...)
 
 The rest: (C) Thomas Hergenhahn (thomas.hergenhahn@web.de) 2001.

 VISUAL is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 VISUAL is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Visual; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
*/

#include "persist.h"
#include <stdio.h>
#include "plclog.h"
#define debug 0

#define ThisModule "persist  : "

const char *base::GetPersistenceID() const
{
    return "base";
}

base::base()
{
    // Do nothing
}

base::~base()
{
//    LOG1 ("~base\n");
    // Do nothing
}

void base::Write(Engine & archive) const
{
    // Do nothing
//    return true;              // Successfully
}

void base::Read(Engine & archive)
{
    // Do nothing
//    return true;              // Successfully
}

TypeManager::StringFunctionMap * theInstantiationFunctions = 0;
int refCount = 0;

TypeManager::StringFunctionMap & _Internal_GetMap()
{
    return *theInstantiationFunctions;
}

void
 TypeManager::Add(const char *name, NewbaseFunction construction)
{
#if debug >0
    LOG2(ThisModule "TypeManager::Add %s\n", string(name).c_str());
#endif
    if (refCount++ == 0) {
#if debug >0
	LOG2(ThisModule "TypeManager: refCount was 0 \n");
#endif
	theInstantiationFunctions = new StringFunctionMap;
    }
    _Internal_GetMap()[string(name)] = construction;
}


void TypeManager::Remove(const char *name)
{
/*
#if debug >0
    LOG2(ThisModule "TypeManager::Remove %s\n", name);
#endif
    _Internal_GetMap().erase(_Internal_GetMap().find(string(name)));
    if (--refCount == 0) {
	delete theInstantiationFunctions;
	theInstantiationFunctions = 0;
    }
*/    
}

base *TypeManager::CreateInstanceOf(const char *name)
{
#if debug > 1
    LOG2(ThisModule "TypeManager::CreateInstanceOf (%s)\n", name);
#endif
    if (_Internal_GetMap().find(string(name)) == _Internal_GetMap().end()) {
	string module = string(name);
	LOG2(ThisModule "CreateInstanceOf : no class for name %s\n",
	       name);
/*	
#if debug >0	
	cout << ThisModule<<"I think I try dlopen a " << module << ".so" <<
	    endl;
#endif
      void *handle2;
      void *handle = dlopen ((module + ".so").c_str (), RTLD_LAZY);
      cout << "persist.cc: dlopen: " << dlerror () << endl;
      bool b = false;
      if (!handle)
	{
	  cout <<"persist.cc: "<< module <<
	    ".so not in library path. I try current directory." << endl;
	  handle = dlopen (("./" + module + ".so").c_str (), RTLD_LAZY);
	  cout << "persist.cc: dlopen: " << dlerror () << endl;
	  if (!handle)
	    {
	      cout << "persist.cc: dlopen: I give up!" << dlerror () << endl;
	    }
	  else
	    b = true;
	}
      else
	b = true;
      if (b)
	{
	  cout << "persist.cc: handle seems ok." << endl;
	  BaseObject *(*constr) ();
	  (void *) constr =
	    dlsym (handle, string ("CreateNew" + module + "__Fv").c_str ());
	  cout << "persist.cc: dlsym: " << dlerror () << endl;
	  Add (module.c_str (), constr);
	  //BaseObject * (*constr)();
	}
*/
	/*
	   is this allways the correct name?
	 */

    }
    return (_Internal_GetMap()[string(name)]) ();
}

/*
    Changes:
    
    05/13/2002 	Object Read & write functions return void now. 
*/
