/*
 Common definitions for a serial line driver for Allen Bradley PLCs

 Part of VISUAL, a human machine interface and data acquisition program
 
 (C) Thomas Hergenhahn (thomas.hergenhahn@web.de) 2002.

 VISUAL is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 VISUAL is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Visual; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
*/
#ifndef AB_lib__
#define AB_lib__

#define STX 0x02
#define ETX 0x03
#define ENQ 0x05
#define ACK 0x06
#define DLE 0x10
#define NAK 0x15

#define uc unsigned char
/*
    This block is for protected typed read with three address fields.
*/
struct AB_block{
    unsigned char dst;
    unsigned char src;
    unsigned char CMD;
    unsigned char STS;
    unsigned char loTNS;
    unsigned char hiTNS;
    unsigned char FNC;
    unsigned char byteSize;
    unsigned char fileNo;
    unsigned char fileType;
    unsigned char eleNo;
    unsigned char XeleNo;
    unsigned char low_S_eleNo;
    unsigned char hi_S_eleNo;
    unsigned char data[500];
};

struct AB_block2{
    unsigned char dst;
    unsigned char src;
    unsigned char CMD;
    unsigned char STS;
    unsigned char loTNS;
    unsigned char hiTNS;
    unsigned char loADR;
    unsigned char hiADR;
    unsigned char byteSize;
    unsigned char data[500];
};

unsigned short  calc_CRC(unsigned char * ,int size) ;

#endif //AB_lib__
