#ifndef __modbus
#define __modbus

#ifdef __cplusplus 
extern "C" {
#endif

#define mbfuncREAD_OUTPUT_REGISTERS	3
#define mbfuncREAD_INPUT_REGISTERS	4
#define mbfuncREAD_OUTPUT_STATUS	1
#define mbfuncREAD_INPUT_STATUS		2
#define mbfuncPRESET_MULTIPLE_REGISTERS	16
#define mbfuncPRESET_SINGLE_REGISTER	6
#define mbfuncLOOP_BACK_TEST 		8
#define mbfuncFORCE_SINGLE_COIL 	5
#define mbfuncFORCE_MULTIPLE_COILS 	15


#pragma pack (1)
#include "mytypes.h"
struct modbusMessage {
    uc hi_ti;			// Transaction identifier 
    uc lo_ti;			// Transaction identifier 
    uc hi_pi;			// Protocol identifier 
    uc lo_pi;			// Protocol identifier 
    uc hi_len;			// Length field 
    uc lo_len;			// Length field 
    uc unit_id;			// Unit identifier
    uc function;		// Function number
    uc ddd[256];
};

char * modbusFunctionName(int function);
int modbusSend(int len, int * transaction_id, int tmo_read, struct modbusMessage * msg, int wfd);
int openSocket(const int port, const char * peer);

#ifdef __cplusplus 
}
#endif

#endif
