/*
 Definitions for a Modbus driver.

 Part of VISUAL, a human machine interface and data acquisition program
 
 (C) Thomas Hergenhahn (thomas.hergenhahn@web.de) 2005.

 VISUAL is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 VISUAL is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Visual; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
*/

#include <sys/types.h>
#include <sys/time.h>
#include <unistd.h>
#include "mytypes.h"
#include "PLCdriver.h"
#include "cellList.h"
#include "cell.h"
#include "lib0.h"
#include <stdio.h>
#include "plclog.h"

#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdio.h>
#include <errno.h>
#include "nethelp.h"

#include "byteswap.h"

#include "vi_string.h"

#include "modbus.h"

#define uc unsigned char

class modbusTI:public TFI {
  public:
    int wordCount;
    DECLARE_PERSISTENCE(modbusTI)
    void Read(Engine & e);
    int function;
};

class modbusDriver:public PLCdriver {
  public:
    word DriverNr;
    modbusTI *pa;
    word DriverState;
    modbusMessage msg;
    int transaction_id;
    uc ibuf[1500];
    int tmo_read;
    int errorCode;
    string peer;
    modbusDriver();
    int readChars(int size);
    void sendmodbus(int len);
//    void watchdog_reset();
    virtual int checkAnswer(int i, int count, int func);
    virtual void intSetup(DriverInfo * i);
    void execute();
    void openSock();
    virtual int protocolRead(TFI * p);
    virtual int protocolWrite(TFI * p, int PLCadr, uc * data,int length);
    virtual uc * getProtocolData();
};
/*
    Changes:
    
    08/21/2005	written
*/
