/*
 Definitions of a cell reference for the spreadsheet. This is like a "pointer" to
 another cell. Everything that is don with the reference, is done to the cell
 referred to. These references may be useful to handle small recipes collections.
 
 Part of VISUAL, a human machine interface and data acquisition program
 
 (C) Thomas Hergenhahn (thomas.hergenhahn@web.de) 2001.

 VISUAL is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 VISUAL is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
*/

#ifndef __refcell
#define __refcell

class RefCell: public tCell {	// This is a sort of pointer to another cell
    // time of last change. 
    coord cIndex;
    coord rIndex;
    int sheet;
  public:
    DECLARE_PERSISTENCE(RefCell)
    RefCell();
    RefCell(word r, word c);
    virtual string typeST() {
	return ("REFCELL");
    } 
    virtual int typeID() {
	return (tRefCell);
    }
    virtual string stringContents(int, int) {
	return ("->" + text);
    }
    virtual void Read(Engine & e);
    void setupFromString();
    coord getTargetCoord();
    virtual string typeString();
    virtual double getVal();
    virtual void setVal(double d);
    
    virtual cell * getRealCell();
    virtual string getViewerText(int decimals, bool preferText);
    virtual int getError();
    virtual void setError(int e);
    virtual double getPreVal();
    virtual void setPreVal(double d);

    virtual int getSourceType();
    virtual void setSourceType(int s);
    virtual unsigned int getCflags();
    virtual void setCflags(unsigned int c);
    virtual unsigned int getFlags();
    virtual void setFlags(unsigned int c);
    virtual unsigned int getState();
    virtual void setState(unsigned int c);
};

#endif
