/*
 reflist.cc: A function that lists the cells a formula depends on. 
 It depends on their values.

 Part of VISUAL, a human machine interface and data acquisition program
 
 (C) Thomas Hergenhahn (thomas.hergenhahn@web.de) 2001.

 VISUAL is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 VISUAL is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Visual; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
*/
#include "cell.h"
#include "list.h"
#include "pString.h"
#include "ptokens.h"
#define debug 0

#if debug >0
#include "lib0.h"
#include <stdio.h>
#endif

#include "reflist.h"

#define ThisModule "reflist  : "

#if debug >0
void wo(void *p, void *)
{
    LOG2(ThisModule "cr: %s\n", cellN(*((coord *) p)));
}
#endif
/*
    coordWrapper::~coordWrapper(){
	free(waste);
	LOG1("~coordWrapper");
    }

    coordWrapper::coordWrapper(coord ak){
	k2.l=ak.l;
	waste=calloc(10000000,1);
	((char *)waste)[44444]='A';
	((char *)waste)[6444]='A';
	((char *)waste)[54444]='A';
	((char *)waste)[44]='A';
	((char *)waste)[444444]='A';
	((char *)waste)[4444444]='A';
	((char *)waste)[434444]='A';
	((char *)waste)[4344444]='Q';
	LOG2("waste: %p\n",waste);
    }
*/    

void reflist(cell * ce, list * l)
{
    char c;
    coord k;
    if (ce == NULL)
	return;
    if ((ce->typeID() != tfCell) && (ce->typeID() != tfTimeCell))
	return;
    int i = 0;
    pString *TPN = &(((fCell *) ce)->TPN);
    while (i < ((fCell *) ce)->TPN.length()) {
	c = TPN->at(i);
	i++;
	switch (c) {
	case ptDOUBLE:
	    i += sizeof(double);
	    break;
	case ptCELL:
	case ptDIFF:
	    k = TPN->getCoord(i);
	    
#if debug >0
		LOG2(ThisModule "ref.to: %s\n", cellN(k));
	    FLUSH;
#endif
//	    l->insert(new coord(k));
//	    l->insert(new coordWrapper(k));
	    l->insert(new coordW(k));
	    break;
	case 'U':
	    i += 2;
	    break;
	}
//      i++; 

    }
#if debug >0
    l->forEach(wo, NULL);
#endif
}
/*
    Changes:
    11/04/2004 	Added a newline and this changes list.
*/
