/*
 Stand-alone test for basic communication with SIEMENS S5 series PLCs via 
 programmer port.
 See www.runmode.com for information about the underlying AS511
 protocol and a proposal of circuit to connect the current loop programmer
 port to a common V24.

 Part of VISUAL, a human machine interface and data acquisition program
 
 (C) Thomas Hergenhahn (thomas.hergenhahn@web.de) 2001.

 VISUAL is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 VISUAL is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Visual; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
*/
#include <sys/types.h>
#include <sys/time.h>
#include <unistd.h>
#include "mytypes.h"
#include "cellList.h"
#include "cell.h"
#include <termios.h>
#include <stdio.h>
#include <fcntl.h>
#include <errno.h>
#include "s5.h"
#include "s5l.h"
#include "setport.h"

#include "vi_string.h"

#define debug 1

#if debug >0
#define ThisModule "S5L     : "
#endif				/*  */

main()
{
    sysPars sp;
    int fd = setPort("/dev/ttyS1 9600 e 8 2");
    cout << getSysPars(fd, &sp, false) << endl;
    cout << getSysPars(fd, &sp, true) << endl;
    cout << "b1:" << (unsigned int) sp.b1 << endl;
    cout << "b2:" << (unsigned int) sp.b2 << endl;
    cout << "b3:" << (unsigned int) sp.b1 << endl;
    cout << "b4:" << (unsigned int) sp.b4 << endl;
    cout << "b5:" << (unsigned int) sp.b5 << endl;
    cout << "in:" << hex << _swap(sp.Inputs) << " " << sp.Inputs << endl;
    cout << "out:" << hex << _swap(sp.Outputs) << " " << sp.
	Outputs << endl;
    cout << "fl:" << hex << _swap(sp.Merker) << " " << sp.Merker << endl;
    /*
       int a=40;
       cout<<hex<<_swap(a)<<" "<<a<<endl;
       cout<<sizeof(sp)<<endl;
       cout<<((int)&sp.Inputs-(int)&sp)<<endl;
       blockInfo BI;
       getBlockInfo(fd, bt_FB, 251, &BI);
     */
}
