/*
 Definitions for a spreadsheet viewer/editor based on TURBOVISION 
 library. TURBOVISION is still copyrighted by Borland, but you get it
 for free with SuSE Linux.

 Part of VISUAL, a human machine interface and data acquisition program
 
 (C) Thomas Hergenhahn (thomas.hergenhahn@web.de) 2001.

 VISUAL is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 VISUAL is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Visual; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
*/
#ifndef __shview
#define __shview

#define Uses_TView
#define Uses_TWindow
#include "tvision/tv.h"
#include "mytypes.h"
#include "cell.h"
#include "ediCellList.h"

#include "vi_string.h"

#define DispX1  3
#define DispY1  3

 class CellDetailView:public TView {
    // displays detailed information
    // in the bottom lines of ShWin
  public:
    CellDetailView(const TRect & r);
//    ~CellDetailView();
    virtual void draw();
};



class ShWin:public TWindow {
  public:
    ShWin(TRect & r);
    ShWin();
    int CurX, CurY;
    int shNumber;
    
//    ShParms: Record
    int shOptions;
    int ColWidth;
    int Decimals;
    int Xoff, Yoff, DispX2, DispY2;
    coord AreaS;		// start of an Area
    coord AreaE;		// end of an Area
    bool AreaValid;		// Area is set
    char markArea;		// 0=ready, 1=mark 1st corner , 2=mark second corner
    virtual void handleEvent(TEvent & Event);
    coord ccPos();
    int curCol();
    int curRow();
    void moveSheet(int x, int y);
    void moveAbs(int x, int y);
    void curMove(TEvent & event);
    void editCell();
    void editLabel();
    void findCellOfType(int type);
    virtual Boolean valid(ushort command);
    virtual ~ShWin();
};

class ShView:public TView {
  public:
    ShView(const TRect & r);
    virtual void draw();
    string drawCell(cell * z,ShWin*own);
};
#endif				/* __shview */
/*
    Changes:
    02/23/2003 	changed include <tvision/...> to "tvision/..."
*/
