/*
 Definitions of a basic structure for modules which are calledif a cell
 changes its value.

 Part of VISUAL, a human machine interface and data acquisition program
 
 (C) Thomas Hergenhahn (thomas.hergenhahn@web.de) 2001.

 VISUAL is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 VISUAL is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Visual; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
*/
#ifndef _plcdrv
#define _plcdrv_

#include <sys/time.h>
#include "base.h"
#include "lib0.h"
#include <stdio.h>
#include "cellList.h"
#include "persist.h"
#include "plcdrv.h"
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include <iostream>
#include <fstream>
#define ThisModule "text_rec  : "

class Module:public client {
  public:
    int errorMask;		// bit Mask to mark errors as originating from this driver
    int changedMask;		// bit to extract drvers "new value flag" set by 
    // calculation thread
    string path;		// a data path
     Module(DriverInfo * di);
    list *il;			//list of transfer instructions
    virtual void callBack(ClientInfo * ci);
    void init(const string & cs);
};


void Module::init(const string & cs)
{
    cell *c = sheets[1]->find(getPos(cs));
    if (c != NULL) {
	c->cflags |= changedMask;
	string pp = path + digits(1) + "/" + cs + ".mdt";
	cout << ThisModule << "try:" << pp << endl;
	int fd = open(pp.c_str(), O_RDWR | O_CREAT, 0644);
	cout << ThisModule << "fd:" << fd << " " << strerror(errno) <<
	    endl;
	close(fd);
    }
}

Module::Module(DriverInfo * di)
{
    changedMask = registerModule(di->s1, this);
    path = noSpace(di->s);
    init("B5");
    init("B6");
    init("B7");
    init("B8");
    init("B9");
    init("B10");
    init("B11");
    init("B12");
    init("B13");
    init("B14");
    init("B15");
    init("B16");
    init("B17");
    init("B18");
    init("B19");
    init("B20");
    init("B21");
    init("B22");
    init("B23");
    init("B24");
    init("B25");
    init("B26");
    init("B27");
    init("B28");
    init("B29");
    init("B30");
    init("B31");
    init("B32");
    init("B33");
    init("B34");
    init("B35");
    init("B36");
    init("B37");
    init("B38");
    init("B39");
    init("A5");
    init("A6");
    init("A7");
    init("A8");
    init("A9");
}



void Module::callBack(ClientInfo * ci)
{
#if debug >3
    cout << ThisModule << "enter callBack." << endl;
    cout << ThisModule << ci->sheet << ":" << cellName(ci->c->k) <<
	"changed to:" << ci->c->value << endl;
#endif
    string pp =
	path + digits(ci->sheet) + "/" + cellName(ci->c->k) + ".mdt";
#if debug >3
    cout << ThisModule << "I will record this to" << pp << endl;
#endif
    fstream f(pp.c_str(), ios::app);
    time_t t = time(NULL);
    string ct = ctime(&t);
#ifndef use_string_2
    f << ct.substr(0,
		   ct.length() -
		   2) << " " << cellName(ci->c->k) << " " << ci->c->
	value << endl;
#else
    f << ct.before(int (ct.length() - 2)) << " " << cellName(ci->c->
							     k) << " " <<
	ci->c->value << endl;
#endif
    f.close();
#if debug >3
    cout << ThisModule << "fd:" << fd << strerror(errno) << endl;
#endif
    cout.flush();
}

void setup(void *arg)
{
    DriverInfo *di = (DriverInfo *) arg;
    cout << ThisModule << "enter setup. list:" << di->
	s1 << " path:" << di->s << endl;
    Module *drv = new Module(di);
    cout.flush();
}



#endif
