import java.util.*;
import java.awt.*;
import java.applet.*;
import java.net.*;
import java.io.*;
import java.awt.event.*;

/**
    A calendar widget to choose days in trend diagrams.
*/
public class calendar extends Applet implements setAbleA,MouseListener {

/**
    Returns start date as seconds since Jan 1 1970
*/
  public long getStart(){
    return(startD.getTime()/1000L);
  };
/**
    Returns end date as seconds since Jan 1 1970
*/  
  public long getEnd(){
    return(endD.getTime()/1000L);
  };
/**
    Set start and end date from another applet.
*/
  public void setValues(long e,long s){
    startD.setTime(s*1000L);
    endD.setTime(e*1000L);
    G.setTime(endD);
    G.add(Calendar.DATE,-63);                // 63 days backward
    while (G.get(Calendar.DAY_OF_WEEK)!=2){  // and forward till monday
      G.add(Calendar.DATE,1);
    }
    kStartD=G.getTime();                      // start of calendar display
    repaint();
  };

  public void mouseClicked(java.awt.event.MouseEvent evt)
  {
     int ex,ey,kx,ky;
     ex=evt.getX();
     ey=evt.getY();
     if ((ex>x)&&(ey>0)&&(ex<x+7*sx)&&(ey<y)){
       kx=(ex-x)/sx2;
       G.setTime(kStartD);
       if (kx==0) {
         G.add(Calendar.DATE, -7);
       }
       if (kx==1) {
         G.add(Calendar.DATE, -28);
       }
       if (kx==2) {
         G.add(Calendar.DATE, -364);
       }
       kStartD=G.getTime();
       repaint();
     }
     if ((ex>x)&&(ey>y+9*sy)&&(ex<x+7*sx)&&(ey<y+10*sy)){
       kx=(ex-x)/sx2;
       G.setTime(kStartD);
       if (kx==0) {
         G.add(Calendar.DATE, 7);
       }
       if (kx==1) {
         G.add(Calendar.DATE, 28);
       }
       if (kx==2) {
         G.add(Calendar.DATE, 364);
       }
       kStartD=G.getTime();
       repaint();
     }
     if ((ex>x)&&(ey>y)&&(ex<x+7*sx)&&(ey<y+9*sy)){
         kx=(ex-x)/sx;
         ky=(ey-y)/sy;
         G.setTime(kStartD);
         G.add(Calendar.DATE, kx+7*ky);
         if (evt.isMetaDown()){
             endD=G.getTime();
         } else {
             startD=G.getTime();
         }
         if (endD.before(startD)){
            D=startD;
            startD=endD;
            endD=D;
            }
         repaint();
     }
  }

  public void mousePressed(java.awt.event.MouseEvent evt)
  {
  }

  public void mouseReleased(java.awt.event.MouseEvent evt)
  {
  }

  public void mouseEntered(java.awt.event.MouseEvent evt)
  {
  }

  public void mouseExited(java.awt.event.MouseEvent evt)
  {
  }

  AppletContext context;
  final int x=35, y=60, sx=24, sy=24, sx2=(sx*7)/3;
  final String monthName[]={"Jan","Feb","Mar","Apr","May","Jun","Jul","Aug",
                            "Sep","Oct","Nov","Dec"};
  final String dayName[]={"none","Mo","Tu","We","Th","Fr","Sa","Su"};
  final Font F16 = new Font("Arial", Font.BOLD, 16);
  final Font F8 = new Font("TimesRoman", Font.PLAIN, 12);
  GregorianCalendar G;
  Date D, startD, endD, kStartD;

public void paint(Graphics g){
  G.setTime(kStartD);
  g.setFont(F8);
  g.setColor(Color.black);
  for (int i=0; i<3; i++) {
    g.drawRect(x+sx2*i+1,11,sx2-2,sy-2);
    g.drawRect(x+sx2*i+1,y+9*sy+2,sx2-2,sy-2);
  }
  g.drawString("1 Week",x+sx/4,23);
  g.drawString("back",x+sx/4,33);
  g.drawString("4 Weeks",sx2+x+sx/4,23);
  g.drawString("back",sx2+x+sx/4,33);
  g.drawString("1 Year",2*sx2+x+sx/4,23);
  g.drawString("back",2*sx2+x+sx/4,33);
  g.drawString("1 Week",x+sx/4,13+9*sy+y);
  g.drawString("formard",x+sx/4,23+9*sy+y);
  g.drawString("4 Weeks",sx2+x+sx/4,13+9*sy+y);
  g.drawString("forward",sx2+x+sx/4,23+9*sy+y);
  g.drawString("1 Year",2*sx2+x+sx/4,13+9*sy+y);
  g.drawString("forward",2*sx2+x+sx/4,23+9*sy+y);
  g.setColor(Color.black);
  g.setFont(F16);
  g.drawString(String.valueOf(G.get(Calendar.YEAR)),0,y-sy/4);
  for (int i=0; i<7; i++) {
    g.drawString(dayName[i+1],x+4+sx*i,y-sy/4);
  }
  for (int j=0; j<9; j++) {
    g.setColor(Color.green);
    g.drawString(monthName[G.get(Calendar.MONTH)],x-sx-10,y+(j+1)*sy);
    for (int i=0; i<7; i++)
         {
              D=G.getTime();
              if ((D.after(startD)||D.equals(startD))
                &&(D.before(endD)||D.equals(endD)))    {
                  g.setColor(Color.yellow);
                  g.fillRect(x+sx*i,y+(j)*sy,sx,sy);
              }
              g.setColor(Color.black);
              g.drawRect(x+sx*i,y+(j)*sy,sx,sy);
              if (G.get(Calendar.DAY_OF_WEEK)==1) {
                g.setColor(Color.red);}
              else {
                g.setColor(Color.black);
              }

              g.drawString(
                 String.valueOf(G.get(Calendar.DATE)),x+sx/4+sx*i,
                                y+(j+1)*sy-sy/4);
              G.add(Calendar.DATE,1);
         }
    }
    g.setFont(F8);
    g.setColor(Color.black);
    g.drawString("from "+String.valueOf(startD),5,315);
    g.drawString("to "+String.valueOf(endD),5,330);

}

public void init() {
  G=new GregorianCalendar();
  endD=G.getTime();                        // set end time to now
  G.setTime(endD);
  G.add(Calendar.DATE,-7);			
  startD=G.getTime();                      // set start to 1 week before
  G.setTime(endD);                         
  context=getAppletContext();			
  G.add(Calendar.DATE,-63);                // subtract 63 days
  while (G.get(Calendar.DAY_OF_WEEK)!=2){  // add days until it's a monday
	G.add(Calendar.DATE,1);
  }
  kStartD=G.getTime();                      // Beginn der Kalenderanzeige
  addMouseListener(this);
}

}


