import java.util.*;
import java.awt.*;
import java.applet.*;
import java.net.*;
import java.io.*;
import java.awt.event.*;

class trendLine {
    String fileName,	// Name of data file
	name; 		// Name (label) of measured data
    trendViewer apple;	 
    trendCanvas owner;	// Diagram canvas
    boolean repaint;	// Trend curve must be drawn again
    int points;		// Number of valid points (time/value pairs)
    int nr;
    int mode=0;		// drawing mode 
			// 0=connect points with direct line
			// 1=mark points with crossed lines (x's)
			// 2=draw horizontal line from last point's x to new x,
			//   then vertical to new y. This is for digital data.
			//   or when you assume data remained unchanged until 
			//   recorded again.
    int xSize;		// trend width
    double xFak,	// time scale
         xwerte[],	// time values
         werte[],	// measurement values
	 startTime,
	 endTime;	
//
// Method init() initializes values
//
public void init(String fileName, trendViewer Apple, trendCanvas owner, int nr){
    this.fileName=fileName;
    this.apple=Apple;	// the main applet
    this.owner=owner;	// my canvas
    this.nr=nr;		
    mode=owner.mode;
    String modes=apple.getParameter(String.valueOf(nr)+"mode");
    if (modes!=null) {
	try {
	    mode=(new  Integer(modes)).intValue();
	}
	catch (NumberFormatException e) {
	}
    }
    System.out.println("open "+fileName);
    name=apple.getParameter(String.valueOf(nr)+"name");
    System.out.println(name);
    String time=apple.getParameter(String.valueOf(nr)+"last");
    System.out.println("jetzt: "+time);
    try {
	endTime=((new  Double(time)).doubleValue());
    }
    catch (NumberFormatException e) {
	System.out.println("Exc.time "+time);
    }
    time=apple.getParameter(String.valueOf(nr)+"T0");	  
    System.out.println("jetzt: "+time);
    try {
         startTime=((new  Double(time)).doubleValue());
    }
    catch (NumberFormatException e) {
	System.out.println("Exc.time "+time);
    }
    if (nr==0) {
	owner.endTime=endTime;
	owner.startTime=startTime;
    } else {
	if (endTime>owner.endTime) owner.endTime=endTime;
	if (startTime<owner.startTime) owner.startTime=startTime;
    }
    owner.intervall=owner.endTime-owner.startTime;
    time=apple.getParameter(String.valueOf(nr)+"points");	  
    points=(new  Integer(time)).intValue();
    werte = new double[points];
    xwerte = new double[points];
    reload();
}

//
// Method reload() loads all values
//
public void reload(){
    int i;
    double prevX, prevY, dx,dy;
    owner.setCursor(new Cursor(Cursor.WAIT_CURSOR));
    for (i=0; i<points; i++){  
	getXYPair(i);
    }
    System.out.println("Maximum : "+String.valueOf(owner.max));
    System.out.println("Minimum : "+String.valueOf(owner.min));
    System.out.println("First   : "+String.valueOf(xwerte[0]));
    System.out.println("Last    : "+String.valueOf(xwerte[points-1]));
    owner.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
}

//
// Method getXYPair() loads a time/value pair
//
public void getXYPair(int iii){
    int i,p;
    String S1=apple.getParameter(String.valueOf(nr)+"T"+String.valueOf(iii));
//    System.out.print("X: "+S1);
    try {
	xwerte[iii]=((new  Double(S1)).doubleValue()); // nach Zahl wandeln
    }
    catch (NumberFormatException e) {
	System.out.println("Exc.X "+S1);
	xwerte[iii]=0.0; // not a number
    }
    S1=apple.getParameter(String.valueOf(nr)+"V"+String.valueOf(iii));
//    System.out.println(" Y: "+S1);
    try {
	werte[iii]=((new  Double(S1)).doubleValue()); // convert to number
    }
    catch (NumberFormatException e) {
	System.out.println("Exc.Y "+S1);
	werte[iii]=0.0; // not a number
    }
    if ((!owner.fixedMax)&&(werte[iii]>owner.max)) owner.max=werte[iii]; 
    if ((!owner.fixedMin)&&(werte[iii]<owner.min)) owner.min=werte[iii];
}

/*
public void mark(double mtime,int x,int y) {
  mtime-=owner.starttime;
  if (mtime>=0.0){
      double t=mtime*xFak+0.5;
      int ii=seekTimePoint(mtime);
      double f=werte[ii];
      f=((f-owner.min)/(owner.max-owner.min))*sy*0.97;
//      g.drawLine(x+(int)t, y+sy-(int)f-10, x+(int)t, y+sy-(int)f+10);
      int xpoints[]={x+(int)t,x+(int)t,x+(int)t-5};
      int ypoints[]={y+sy-(int)f, y+sy-(int)f-13,y+sy-(int)f-10};
      g.fillPolygon(xpoints,ypoints,3);
    }
}  
*/  

//
// Method paint() draws a trendLine into the region width sx,
// height sy, upper left corner x,y.
//
public void paint(Graphics g, int x, int y, int sx, int sy) {
    int ycenter;
    double f, fAlt, t, tAlt, tmin;
    int ii;
    xSize=sx;
    xFak=xSize/(owner.endTime-owner.startTime); // Factor time<->width
    repaint = false;
    tmin=owner.startTime;
    t=xwerte[0];
    tAlt=(t-tmin)*xFak;
    fAlt=werte[0];
//    if (fAlt>maxy) maxy=fAlt;
//    if (fAlt<miny) miny=fAlt;
    fAlt=((fAlt-owner.min)/(owner.max-owner.min))*sy*0.97;
    for (ii=1; ii<points; ii++){
	f=werte[ii];
	t=xwerte[ii];
//         if (f>maxy) {maxy=f;repaint=true;}
//         if (f<miny) {miny=f;repaint=true;}
        
        t=(t-tmin)*xFak;
	if (mode==3) {
	    int  bm=1,by,byAlt;
	    for (int ib=0; ib<8; ib++){ 
//		System.out.println("alt: "+fAlt+" neu: "+f+" mask: "+bm);
		if (((int)fAlt & bm)>0) byAlt=10; else byAlt=0;
		if (((int)f & bm)>0) by=10; else by=0;
		g.drawLine(x+(int)tAlt, y+sy-byAlt-30*ib, x+(int)t, y+sy-byAlt-30*ib);
		g.drawLine(x+(int)t, y+sy-byAlt-30*ib, x+(int)t, y+sy-by-30*ib);
		bm=bm*2;
	    }
	} else {
	    f=((f-owner.min)/(owner.max-owner.min))*sy*0.97;
	    if (mode==2) {
		g.drawLine(x+(int)tAlt, y+sy-(int)fAlt, x+(int)t, y+sy-(int)fAlt);
		g.drawLine(x+(int)t, y+sy-(int)fAlt, x+(int)t, y+sy-(int)f);
	    } else {
		if (mode==1) {
		    g.drawLine(x+(int)t-1, y+sy-(int)f-1, x+(int)t+1, y+sy-(int)f+1);
		    g.drawLine(x+(int)t-1, y+sy-(int)f+1, x+(int)t+1, y+sy-(int)f-1);
		} else 
		    g.drawLine(x+(int)tAlt, y+sy-(int)fAlt, x+(int)t, y+sy-(int)f);
		}    
	    }
//		if ((xwerte[ii-1]<=owner.smark)&&(xwerte[ii]>=owner.smark)){
//	   g.drawLine(x+(int)t, y+sy-(int)f-10, x+(int)t, y+sy-(int)f+10);
//	 }
	    tAlt=t;
	    fAlt=f;
	}
//
// In mode 2, assume last value lasts until now. Draw a hor.line to the end
//    
	if (mode==2) {
	    g.drawLine(x+(int)tAlt, y+sy-(int)fAlt, x+sx, y+sy-(int)fAlt);
	}
	owner.setFont(g, 12);
    
	System.out.println("smark: "+owner.smark+" emark: "+owner.emark);
	g.setColor(Color.black);      
	if (owner.smark!=0.0){
	    t=(owner.smark-tmin)*xFak+0.5;
	    ii=seekTimePoint(owner.smark);
	    f=werte[ii];
	    double iv=xwerte[ii+1]-xwerte[ii];
	    double rs=owner.smark-xwerte[ii];
	    double vv=rs/iv;
	    double dy=werte[ii+1]-werte[ii];
	f+=vv*dy;
	System.out.print("x: "+xwerte[ii]+" x+1: "+xwerte[ii+1]);
	System.out.print("y: "+werte[ii]+" y+1: "+werte[ii+1]);
	f=((f-owner.min)/(owner.max-owner.min))*sy*0.97;
//      g.drawLine(x+(int)t, y+sy-(int)f-10, x+(int)t, y+sy-(int)f+10);
	int xpoints[]={x+(int)t,x+(int)t,x+(int)t-5};
	int ypoints[]={y+sy-(int)f, y+sy-(int)f-13,y+sy-(int)f-10};
	g.fillPolygon(xpoints,ypoints,3);
    }
    if (owner.emark!=0.0){
	t=(owner.emark-tmin)*xFak+0.5;
	ii=seekTimePoint(owner.emark);
	f=werte[ii];
	double iv=xwerte[ii+1]-xwerte[ii];
	double rs=owner.emark-xwerte[ii];
	double vv=rs/iv;
	double dy=werte[ii+1]-werte[ii];
	f+=vv*dy;
	f=((f-owner.min)/(owner.max-owner.min))*sy*0.97;
	int xpoints[]={x+(int)t,x+(int)t,x+(int)t+5};
	int ypoints[]={y+sy-(int)f, y+sy-(int)f-13,y+sy-(int)f-10};
	g.fillPolygon(xpoints,ypoints,3);
    }
}

public int seekTimePoint(double time){
    int e=points-1;
//    int e=points;
    int a=0,middle,cnt=4*points;
    double tv;
    do {
	middle=(a+e)/2;
	tv=xwerte[middle];
	cnt/=2;
	if (tv<time) a=middle; else e=middle;
    } while(cnt>1);
    return(middle);
}

public String textPair(double x) {
    double time=owner.startTime+(x/xFak);
    int i=seekTimePoint(time);
    Date D=new Date();
    D.setTime((long)(xwerte[i]*1000));
    return(String.valueOf(D)+" "+String.valueOf(werte[i]));
}

}

class ArcControls extends Panel 
{
      trendCanvas canvas;
      
public ArcControls(trendCanvas canvas) {
    this.canvas = canvas;
    Button b= new Button("-1 Woche");b.addActionListener(canvas);add(b);
    b= new Button("<<");b.addActionListener(canvas);add(b);
    b= new Button("<");b.addActionListener(canvas);add(b);
    b= new Button(">");b.addActionListener(canvas);add(b);
    b= new Button(">>");b.addActionListener(canvas);add(b);
    b= new Button("+1 Woche");b.addActionListener(canvas);add(b);
    b= new Button("Neuzeichnen");b.addActionListener(canvas);add(b);
}
/*
public boolean action(Event ev, Object arg) {
    if (ev.target instanceof Button) {
        String label = (String)arg;
        if (label.equals("+1 Woche")) canvas.endTime+=86400*7;
        if (label.equals(">>")) canvas.endTime+=canvas.intervall;
        if (label.equals(">")) canvas.endTime+=canvas.intervall/10;
        if (label.equals("<")) canvas.endTime-=canvas.intervall/10;
        if (label.equals("<<")) canvas.endTime-=canvas.intervall;
        if (label.equals("-1 Woche")) canvas.endTime-=86400*7;
        if (label.equals("Neuzeichnen")){
	    if (canvas.Kalender==null) canvas.initKalender();
	    if (canvas.Kalender!=null){
		canvas.endTime=canvas.Kalender.getEnd();
		canvas.startTime=canvas.Kalender.getStart();
		canvas.intervall=canvas.endTime-canvas.startTime;
	    }
	    canvas.owner.callTrend();
        }
	canvas.startTime=canvas.endTime-canvas.intervall;
	canvas.reload();
	return true;
    }
    return false;
}


*/
/*
public void actionPerformed(ActionEvent ev) {
//    if (ev.target instanceof Button) {
//        String label = (String)arg;
	String label =ev.getActionCommand();
        if (label.equals("+1 Woche")) canvas.endTime+=86400*7;
        if (label.equals(">>")) canvas.endTime+=canvas.intervall;
        if (label.equals(">")) canvas.endTime+=canvas.intervall/10;
        if (label.equals("<")) canvas.endTime-=canvas.intervall/10;
        if (label.equals("<<")) canvas.endTime-=canvas.intervall;
        if (label.equals("-1 Woche")) canvas.endTime-=86400*7;
        if (label.equals("Neuzeichnen")){
	    if (canvas.Kalender==null) canvas.initKalender();
	    if (canvas.Kalender!=null){
		canvas.endTime=canvas.Kalender.getEnd();
		canvas.startTime=canvas.Kalender.getStart();
		canvas.intervall=canvas.endTime-canvas.startTime;
	    }
	    canvas.owner.callTrend();
        }
	canvas.startTime=canvas.endTime-canvas.intervall;
	canvas.reload();
//	return true;
//    }
//    return false;
}
*/
}

class trendCanvas extends Canvas implements MouseListener,
KeyListener,
ActionListener
{
    static final int leftBorder=30;   // linker Rand Zeichenflaeche fuer Kurven
    static final int lowerBorder=40;  // unterer Rand Zeichenflaeche fuer Kurven
    static final int upperBorder=20;  // oberer  Rand Zeichenflaeche fuer Kurven
    static final int totalHeight=480; // gesamte Hoehe des Appletbereichs
    static final int ySize=totalHeight
        -upperBorder-lowerBorder;   // Hoehe Zeichenflaeche fuer Kurven
    static final int yGridSteps=30;   // Anzahl der Rasterlinien-1
    static final double yStep=(double)ySize/yGridSteps;
    double intervall = 86400.0,       // anzuzeigender Zeitraum in Sekunden
    smark=0.0,
    emark=0.0;
    ArcControls controls;
//  Image  dbImage;
//  Graphics dbGraphics;
    trendViewer owner;
    int xx, pos, CursX=leftBorder,mode=0;
    boolean needFullPaint=true;
    boolean LupeLeftValid = false;
    boolean fixedMax = false;
    boolean fixedMin = false;
    double max=-1e9, min=1e9, endTime, startTime, LupeLeft, LupeRight;

    final Font F8 = new Font("ArialBlack", Font.BOLD, 8);
    final Font F10 = new Font("Arial", Font.BOLD, 10);
    final Font F12 = new Font("Arial", Font.BOLD, 12);
    final Font F14 = new Font("Arial", Font.BOLD, 14);
    final Font F16 = new Font("Arial", Font.BOLD, 16);
    final Font F18 = new Font("Arial", Font.BOLD, 18);
    final Color myblue=new Color(0,0,0x80);
    final Color mygreen=new Color(0,0x80,0);
    trendLine trends[] = new trendLine[25];
    int count=0, herror=0;
    AppletContext context;
    setAbleA Kalender=null;
    setAbleB Legend;

public void setFont(Graphics g, int fh) {
    if (fh>=18) g.setFont(F18);
    else if (fh>=16) g.setFont(F16);
    else if (fh>=14) g.setFont(F14);
    else if (fh>=12) g.setFont(F12);
    else if (fh>=10) g.setFont(F10);
    else g.setFont(F8);
}

public void actionPerformed(ActionEvent e) {
//    if (e.Source instanceof Button) {
	System.out.println("aP:"+e);
        String label =e.getActionCommand();
	// (String)arg;
        if (label.equals("+1 Woche")) endTime+=86400*7;
        if (label.equals(">>")) endTime+=intervall;
        if (label.equals(">")) endTime+=intervall/10;
        if (label.equals("<")) endTime-=intervall/10;
        if (label.equals("<<")) endTime-=intervall;
        if (label.equals("-1 Woche")) endTime-=86400*7;
        if (label.equals("Neuzeichnen")){
	if (Kalender==null) initKalender();
	if (Kalender!=null){
	    endTime=Kalender.getEnd();
	    startTime=Kalender.getStart();
	    intervall=endTime-startTime;
	}
	owner.callTrend();
    }
    startTime=endTime-intervall;
    reload();
//	return true;
//    }
//    return false;
}

public void keyTyped(java.awt.event.KeyEvent e)
{
}

public void keyPressed(java.awt.event.KeyEvent e)
{
    int lkc=e.getKeyCode();
    int lcc=e.getKeyChar();
    int oldX=CursX;
//       String lastKey=e.getKeyText(lkc);
//       System.out.println("typed");
    switch(lkc){
//		case KeyEvent.VK_DOWN:  curY++;break;
//		case 109: next(-1); break;
//		case 107: next(1);  break;
    case KeyEvent.VK_RIGHT: CursX++;break;
    case KeyEvent.VK_LEFT:  CursX--;break; 
//	case KeyEvent.VK_UP:    curY--;break;
//       case KeyEvent.VK_HOME:  curY=1;curX=1;curY=1;startX=1;startY=1;break;
//       case KeyEvent.VK_E:     edit();break;
//       case KeyEvent.VK_G:     gotoK();break;
//       case KeyEvent.VK_END:   curY=1;curX=xFields;curY=yFields;
//               startX=10000-xFields;
//               startY=10000-yFields;
//               break;                  //end
        }
	Graphics g=getGraphics();
	g.setXORMode(Color.white);
	g.drawLine(oldX, upperBorder, oldX, upperBorder+ySize);
	updateCursor(getGraphics());
  }

  public void keyReleased(java.awt.event.KeyEvent evt)
  {
  }


public void mouseClicked(java.awt.event.MouseEvent evt)
{
    int oldX=CursX;
    CursX=evt.getX();
    if (CursX<leftBorder) CursX=leftBorder;
       if (evt.isMetaDown()) {
          if (LupeLeftValid){
              LupeRight=startTime+(endTime-startTime)
                                 *(CursX-leftBorder)/(640-leftBorder);
              if (LupeLeft>LupeRight) {
                  double c=LupeLeft; LupeLeft=LupeRight; LupeRight=c;
              }
              intervall=LupeRight-LupeLeft;
              endTime=LupeRight;
              startTime=LupeLeft;
              LupeLeftValid=false;
              reload();
          }
          else {
              LupeLeft=startTime+(endTime-startTime)*
                           (CursX-leftBorder)/(640-leftBorder);
              LupeLeftValid=true;
         }
    }
//    repaint();
//	paintCursor();
    Graphics g=getGraphics();
    g.setXORMode(Color.white);
    g.drawLine(oldX, upperBorder, oldX, upperBorder+ySize);
    updateCursor(getGraphics());
}

public void mousePressed(java.awt.event.MouseEvent evt) {
//    System.out.println("mouse pressed"+CursX);
}

public void mouseReleased(java.awt.event.MouseEvent evt) {}

public void mouseEntered(java.awt.event.MouseEvent evt) {}

public void mouseExited(java.awt.event.MouseEvent evt) {}

public void initKalender () {
    Kalender=(setAbleA)context.getApplet("kalender");
    if(Kalender!=null){
	Kalender.setValues((long)endTime,
           (long)startTime);
    }
}
    
public void initLegend () {
    Legend=(setAbleB)context.getApplet("legend");
    System.out.println("Legend: "+Legend);
}    

public void init(int count, trendViewer owner, AppletContext context) {
    this.count=count;
    this.owner=owner;
    this.context=context;
    addMouseListener(this);
    addKeyListener(this);
//    addActionListener(this);
//    addComponentListener(this);
//    addContainerListener(this);
    System.out.println("endTime: "+String.valueOf(endTime));
}

public void paint(Graphics g) {
    String Skal;
    paintFull(g);
    updateCursor(g);
}

public void paintFull(Graphics g) {
    String Skal;
    g.setColor(Color.lightGray);
    g.fillRect(0,upperBorder,640,ySize);
    pos=leftBorder;
    g.setColor(/*myblue*/ Color.white);
    for (int i=0; i<=yGridSteps; i++) {
	g.drawLine(leftBorder, upperBorder+(int)(yStep*i),
		    640, upperBorder+(int)(yStep*i));
    }
    for (int i=0; i<count; i++){
	switch (i%5) {
	    case 1:g.setColor(Color.yellow);break;
	    case 2:g.setColor(mygreen);break;
	    case 3:g.setColor(Color.blue); break;
	    case 4:g.setColor(Color.orange); break;
	    default:g.setColor(Color.red /* Color.white*/);
	}
	trends[i].paint(g, leftBorder, upperBorder, 610, ySize);
    }
    g.setColor(myblue /*Color.white*/);
    g.setFont(F10);
    double skalstep=(max/0.97-min)/yGridSteps;
    for (int i=0; i<=yGridSteps; i++) {
	Skal=String.valueOf(min+i*skalstep);
	int l=Skal.length()-1;
	if (l>5) l=5;
	g.drawString(Skal.substring(0,l),
    		    4, ySize+upperBorder+5-(int)(yStep*i));
    }
    needFullPaint=false;
}

public void reload() {
    for (int i=0; i<count; i++){
	trends[i].reload();
    }
    needFullPaint=true;
    repaint();
}

public void updateCursor(Graphics g) {
//  g.drawImage(dbImage,0,0,this);
//  g.setColor(Color.white);
    g.setXORMode(Color.white);
    g.drawLine(CursX, upperBorder, CursX, upperBorder+ySize);
    g.setPaintMode();
    if (Legend==null) {initLegend();}
    if (Legend!=null){		// test again,initLegend may have failed
	Legend.setNumEntries(count);
    }  
    for (int i=0; i<count; i++){
	Color c;
	switch (i%5) {
	    case 1:c=Color.yellow;break;
	    case 2:c=mygreen;break;
	    case 3:c=Color.blue; break;
	    case 4:c=Color.orange; break;
	    default:c=Color.red ;
	}  //switch
	if (Legend!=null){
	    Legend.setEntry(i, trends[i].name+":  "+trends[i].textPair(CursX-leftBorder),c);
	}      
    } // for
    if (Legend!=null) Legend.myRepaint();
}

}

public class trendViewer extends Applet {
    AppletContext context;
    ArcControls controls;
    trendCanvas c;
    int count=1;
    GregorianCalendar G;
    String trendURL;

    public void init() {
        G=new GregorianCalendar();
        String name=" ", t; 
        int tcount=0;
        context=getAppletContext();
	setLayout(new BorderLayout());
	c = new trendCanvas();
	trendURL=getParameter("script");
	String ps=getParameter("time");
	if (ps!=null) c.intervall=(new  Double(ps)).doubleValue();
	ps=getParameter("mode");
	if (ps!=null) c.mode=(new  Integer(ps)).intValue();
	ps=getParameter("max");
	if (ps!=null) {
	  c.max=(new  Double(ps)).doubleValue();
	  c.fixedMax=true;
	}  
	ps=getParameter("min");
	if (ps!=null) {
	  c.min=(new  Double(ps)).doubleValue();
	  c.fixedMin=true;
	}  
	ps=getParameter("smark");
	if (ps!=null) c.smark=(new  Double(ps)).doubleValue();
	ps=getParameter("emark");
	if (ps!=null) c.emark=(new  Double(ps)).doubleValue();
	add("Center", c);
	add("South", controls = new ArcControls(c));
	ps=getParameter("kurven");
	if (ps!=null) count=(new  Integer(ps)).intValue();
	for (int i=0;i<count;i++){
	    System.out.println("creating trend "+i);
	    c.trends[i] = new trendLine();
	    c.trends[i].init("noname", this, c, i);
        }	
     c.init(count,this,context);
     add("Center", c);
     c.initKalender();
    }
    
    public void start() {
//	controls.enable();
//       controls.addActionListener(this);
//	c.addActionListener(this);
    }

    public void stop() {
//	controls.disable();
    }
    
    public void callTrend() {
    long s,en;
    s=c.Kalender.getStart();
    en=c.Kalender.getEnd();
    
    try{
	context.showDocument(new URL(trendURL
			     +"&start="+String.valueOf(s)
			     +"&end="+String.valueOf(en)
			     ));
     }
     catch (MalformedURLException e){
         System.out.println("Malformed URL:"+trendURL);
     }
}

}


