#include <stdio.h>
#include <unistd.h>		/* for usleep( long ) */
#include <string.h>
#include "vga.h"
#include "vgagl.h"

static unsigned char line[2048 * 3];

static void circle(int mx, int my,int r)
{
int x,y,
    r2,ar2,     // r*r
    nrx,    // new sqared radius if we dec x
    nry,    // new sqared radius if we inc y
    erx,    // error if we dec x
    ery;    // error if we inc y
   r2=r*r;    
   ar2=r2;
   x=r;
   y=0;
  do{
    nry=ar2+2*y+1;	// if we inc y nyr=(y+1)^2+x^2 = y^2+2y+1+x^2 = r^2+2y+1
    nrx=ar2-2*x+1;	// if we dec x nxr=y^2+(x-1)^2 = y^2+x^2-2x-1 = r^2-2x+1
    ery=r2-nry; if (ery<0) ery=-ery;
    erx=r2-nrx; if (erx<0) erx=-erx;
    if (ery<erx) {
          y++; 
	  ar2=nry; 
	  } else {
	  x--; 
	  ar2=nrx;
	  }
      vga_drawpixel(mx+x, my+y);
      vga_drawpixel(mx+x, my-y);
      vga_drawpixel(mx-x, my+y);
      vga_drawpixel(mx-x, my-y); 
   } while (x>0);      
}    

static void ellipse(int mx, int my,int a, int b)
{
int x,y,ye,
    r2,ar2,     // r*r
    nrx,    // new sqared radius if we dec x
    nry,    // new sqared radius if we inc y
    erx,    // error if we dec x
    ery;    // error if we inc y
   r2=a*a;    
   ar2=r2;
   x=a;
   y=0;
  do{
    nry=ar2+2*y+1;	// if we inc y nyr=(y+1)^2+x^2 = y^2+2y+1+x^2 = r^2+2y+1
    nrx=ar2-2*x+1;	// if we dec x nxr=y^2+(x-1)^2 = y^2+x^2-2x-1 = r^2-2x+1
    ery=r2-nry; if (ery<0) ery=-ery;
    erx=r2-nrx; if (erx<0) erx=-erx;
    if (ery<erx) {
          y++; 
	  ar2=nry; 
	  } else {
	  x--; 
	  ar2=nrx;
	  }
      ye=y*b/a;	  
      vga_drawpixel(mx+x, my+ye);
      vga_drawpixel(mx+x, my-ye);
      vga_drawpixel(mx-x, my+ye);
      vga_drawpixel(mx-x, my-ye); 
   } while (x>0);      
}    

static void fillcircle(int mx, int my,int r)
{
int x,y,
    r2,ar2,     // r*r
    nrx,    // new sqared radius if we dec x
    nry,    // new sqared radius if we inc y
    erx,    // error if we dec x
    ery;    // error if we inc y
   r2=r*r;    
   ar2=r2;
   x=r;
   y=0;
  do{
    nry=ar2+2*y+1;	// if we inc y nyr=(y+1)^2+x^2 = y^2+2y+1+x^2 = r^2+2y+1
    nrx=ar2-2*x+1;	// if we dec x nxr=y^2+(x-1)^2 = y^2+x^2-2x-1 = r^2-2x+1
    ery=r2-nry; if (ery<0) ery=-ery;
    erx=r2-nrx; if (erx<0) erx=-erx;
    if (ery<erx) {
          y++; 
	  ar2=nry; 
	  } else {
	  x--; 
	  ar2=nrx;
	  }
      vga_drawline(mx,my,mx+x, my+y);
      vga_drawline(mx,my,mx+x, my-y);
      vga_drawline(mx,my,mx-x, my+y);
      vga_drawline(mx,my,mx-x, my-y);
   } while (x>0);      
}    

static void fillellipse(int mx, int my,int a, int b)
{
int x,y,ye,
    r2,ar2,     // r*r
    nrx,    // new sqared radius if we dec x
    nry,    // new sqared radius if we inc y
    erx,    // error if we dec x
    ery;    // error if we inc y
   r2=a*a;    
   ar2=r2;
   x=a;
   y=0;
  do{
    nry=ar2+2*y+1;	// if we inc y nyr=(y+1)^2+x^2 = y^2+2y+1+x^2 = r^2+2y+1
    nrx=ar2-2*x+1;	// if we dec x nxr=y^2+(x-1)^2 = y^2+x^2-2x-1 = r^2-2x+1
    ery=r2-nry; if (ery<0) ery=-ery;
    erx=r2-nrx; if (erx<0) erx=-erx;
    if (ery<erx) {
          y++; 
	  ar2=nry; 
	  } else {
	  x--; 
	  ar2=nrx;
	  }
      ye=y*b/a;	  
      vga_drawline(mx,my,mx+x, my+ye);
      vga_drawline(mx,my,mx+x, my-ye);
      vga_drawline(mx,my,mx-x, my+ye);
      vga_drawline(mx,my,mx-x, my-ye); 
   } while (x>0);      
}    
/*
static void fillellipse2(int mx, int my,int a, int b)
{
int x,y,ye,
    r2,ar2,     // r*r
    nrx,    // new sqared radius if we dec x
    nry,    // new sqared radius if we inc y
    erx,    // error if we dec x
    ery;    // error if we inc y
   r2=a*a;    
   ar2=r2;
   x=a;
   y=0;
  do{
    nry=ar2+2*y+1;	// if we inc y nyr=(y+1)^2+x^2 = y^2+2y+1+x^2 = r^2+2y+1
    nrx=ar2-2*x+1;	// if we dec x nxr=y^2+(x-1)^2 = y^2+x^2-2x-1 = r^2-2x+1
    ery=r2-nry; if (ery<0) ery=-ery;
    erx=r2-nrx; if (erx<0) erx=-erx;
    if (ery<erx) {
          y++; 
	  ar2=nry; 
	  } else {
	  x--; 
	  ar2=nrx;
	  }
      ye=y*b/a;	  
      vga_drawline(mx-x,my+ye,mx+x, my+ye);
      vga_drawline(mx-x,my-ye,mx+x, my-ye);
   } while (x>0);      
}   
*/
int quad(int angle)
{
   int q;     
   q=1;
   if (angle >90 ) q=2;	// 2:90-180 degrees    
   if (angle >180) q=3;	// 3:180-270 degrees    
   if (angle >270) q=4;	// 4:270-360 degrees     
   return(q);
}   
/*
static void fillellipse3(int mx, int my,int a, int b, int stangle, int endangle)
{
int x,y,ye,
    r2,ar2,     // r*r
    nrx,    // new sqared radius if we dec x
    nry,    // new sqared radius if we inc y
    erx,    // error if we dec x
    ery,    // error if we inc y
    stx,    // x-coordinate of startpoint on boundary
    sty,    // y-coordinate of startpoint on boundary
//    endx,   // x-coordinate of endpoint on boundary
//    endy,   // y-coordinate of endpoint on boundary
    sq,	    // quadrant of startpoint, 1-4
    eq;	    // quadrant of startpoint, 1-4
   sq=quad(stangle);
   eq=quad(endangle);
   r2=a*a;    
   ar2=r2;
   x=a;
   y=0;
  do{
    nry=ar2+2*y+1;	// if we inc y nyr=(y+1)^2+x^2 = y^2+2y+1+x^2 = r^2+2y+1
    nrx=ar2-2*x+1;	// if we dec x nxr=y^2+(x-1)^2 = y^2+x^2-2x-1 = r^2-2x+1
    ery=r2-nry; if (ery<0) ery=-ery;
    erx=r2-nrx; if (erx<0) erx=-erx;
    if (ery<erx) {
          y++; 
	  ar2=nry; 
	  } else {
	  x--; 
	  ar2=nrx;
	  }
      ye=y*b/a;	  
      vga_drawline(mx,my,mx+x, my+ye);
      vga_drawline(mx,my,mx+x, my-ye);
      vga_drawline(mx,my,mx-x, my+ye);
      vga_drawline(mx,my,mx-x, my-ye); 
   } while (x>0);      
}    
*/
static void testmode(int mode)
{
    int xmax, ymax, i, /*x, y,*/ yw, ys /*, c*/;
    vga_modeinfo *modeinfo;

    vga_setmode(mode);

    modeinfo = vga_getmodeinfo(mode);

//    vga_screenoff();

    xmax = vga_getxdim() - 1;
    ymax = vga_getydim() - 1;

    vga_setcolor(vga_white());
    vga_drawline(0, 0, xmax, 0);
    vga_drawline(xmax, 0, xmax, ymax);
    vga_drawline(xmax, ymax, 0, ymax);
    vga_drawline(0, ymax, 0, 0);

    for (i = 0; i <= 15; i++) {
	vga_setegacolor(i);
	vga_drawline(10 + i * 5, 10, 90 + i * 5, 90);
    }
    for (i = 0; i <= 15; i++) {
	vga_setegacolor(i);
	vga_drawline(90 + i * 5, 10, 10 + i * 5, 90);
    }
    vga_setegacolor(14);
//    vga_screenon();
    circle(50,50,25);
    fillcircle(100,50,25);
    vga_setegacolor(12);
    ellipse(50,100,25,40);
    ellipse(100,100,40,25);
    fillellipse(200,200,90,55);
    vga_setegacolor(9);
    fillellipse(400,200,90,55);

    ys = 300;
    yw = (ymax - 100) / 4;
	if (vga_getcolors() == 16) {
	    for (i = 0; i < xmax - 1; i++)
		line[i] = (i + 2) % 16;
	    line[0] = line[xmax] = 15;
	    line[1] = line[xmax - 1] = 0;
	}
	
	if (vga_getcolors() == 2) {
	    for (i = 0; i <= xmax; i++)
		line[i] = 0x11;
	    line[0] = 0x91;
	}
	for (i = 300; i < ymax - 1; i++)
	    vga_drawscanline(i, line);

    if (getchar() == 'd')
	vga_dumpregs();

    vga_setmode(TEXT);
}

int main(void)
{
    int mode;
    vga_init();			/* Initialize. */
    mode = 4;
    if (vga_hasmode(mode))
	testmode(mode);
    else {
	printf("Error: Video mode not supported by driver\n");
	exit(-1);
    }
    return 0;
}
