/*
 Implementation of some viewers for internal data structures. 
 Based on TURBOVISION library. TURBOVISION is still copyrighted by 
 Borland, but you get it for free with SuSE Linux.

 Part of VISUAL, a human machine interface and data acquisition program
 
 (C) Thomas Hergenhahn (thomas.hergenhahn@web.de) 2001.

 VISUAL is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 VISUAL is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Visual; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
*/
#define Uses_TView
#define Uses_TWindow
#define Uses_TEvent
#define Uses_TDeskTop
#define Uses_TProgram
#define Uses_TApplication
#include <tvision/tv.h>
#include "mytypes.h"
#include "cellList.h"
#include "viewcommands.h"
#include "viewers.h"
#include "shcommands.h"

#include "vi_string.h"

#include "tvtoplus.h"

#include "plcdrivers/PLCdriver.h"
#include "lib0.h"
#include "drivers/module.h"

class DriverView:public DynView {
  public:
    DriverView(const TRect & r, TScrollBar * vsb):DynView(r, vsb) {};

    virtual void draw() {
	TDrawBuffer2 buf;
	y = 0;
	buf.moveChar(0, ' ', getColor(1), size.x);
	buf.moveString(0, "Name", 0);
	buf.moveString(11, "Port", 0);
	buf.moveString(22, "Line", 0);
	buf.moveString(36, "Error", 0);
	buf.moveString(46, "Thread", 0);
	buf.moveString(56, "PID", 0);
	buf.moveString(62, "Error", 0);
	buf.moveString(68, "Cycle", 0);
	writeBuf(0, y, size.x, 1, buf);
	y++;
	buf.moveChar(0, ' ', getColor(1), size.x);
	buf.moveString(0, "Name", 0);
	buf.moveString(22, "Parameters", 0);
	buf.moveString(36, "mask", 0);
	buf.moveString(46, "Thread", 0);
	buf.moveString(56, "PID", 0);
	buf.moveString(62, "Error", 0);
	buf.moveString(68, "Count", 0);
	writeBuf(0, y, size.x, 1, buf);
	y++;
	buf.moveChar(0, '-', getColor(1), size.x);
	writeBuf(0, y, size.x, 1, buf);
	y++;
	for (int i = 0; i < 28; i++) {
	    if (registrations[i].mask != 0) {
		buf.moveChar(y, ' ', getColor(1), size.x);
		buf.moveString(0, registrations[i].name, 0);
		if (registrations[i].pointerToInstance) {
/*		
		    base * pp= (base*) registrations[i].pointerToInstance;
		    
		    if (typeof(*pp) == typeof(PLCdriver)){
			buf.moveString(0, "2", 0);
		    } else
			buf.moveString(0, "1", 0);
*/					
		    PLCdriver *p =
			((PLCdriver *) registrations[i].pointerToInstance);
		    if (p->DI)	
			buf.moveString(10, p->DI->s1, 0);
		    else	
			buf.moveString(10, "No DI", 0);
		    buf.moveString(36, ldigits(p->bitMask), 0);
		    buf.moveString(46, digits(p->handle), 0);
		    buf.moveString(56, digits(p->pid), 0);
//		    buf.moveString(62, digits(p->execError), 0);
		    if (p->DI)		
			buf.moveString(62, p->DI->s, 0);
		    else	
			buf.moveString(10, "No DI", 0);	
		    buf.moveString(68, digits(p->execCount), 0);	
		}
		writeBuf(0, y, size.x, 1, buf);
		y++;
	    }
	}
    }
};


void DynView::handleEvent(TEvent & event)
{
    if ((event.what & evMessage) != 0) {
	if (event.message.command == cmshUpdtSheet) {
	    drawView();
	}
    }
//      if (event.what == evCommand) {

//          switch (event.message.command) {
//              case cmshUpdtSheet:     
//                  drawView();
//                  break;
//              default:
//                  return;
//          }       
//        }
    TScroller::handleEvent(event);
};

extern module_registration module_registrations[maxModules];

class ModuleView:public DynView {
  public:
    ModuleView(const TRect & r, TScrollBar * vsb):DynView(r, vsb) {
//          cout<<"DriverView::DriverView()"<<endl;
//          cout.flush();
    };

    virtual void draw() {
	TDrawBuffer2 buf;
	y = 0;
	buf.moveChar(0, ' ', getColor(1), size.x);
	buf.moveString(0, "Name", 0);
	buf.moveString(11, "Port", 0);
	buf.moveString(22, "Line", 0);
	buf.moveString(36, "Error", 0);
	buf.moveString(46, "Thread", 0);
	buf.moveString(56, "PID", 0);
	buf.moveString(62, "Error", 0);
	buf.moveString(68, "Cycle", 0);
	writeBuf(0, y, size.x, 1, buf);
	y++;
	buf.moveChar(0, ' ', getColor(1), size.x);
	buf.moveString(0, "Name", 0);
	buf.moveString(22, "Parameters", 0);
	buf.moveString(36, "mask", 0);
	buf.moveString(46, "Thread", 0);
	buf.moveString(56, "PID", 0);
	buf.moveString(62, "Error", 0);
	buf.moveString(68, "Count", 0);
	writeBuf(0, y, size.x, 1, buf);
	y++;
	buf.moveChar(0, '-', getColor(1), size.x);
	writeBuf(0, y, size.x, 1, buf);
	y++;
//          cout<<"DriverView::draw()"<<endl;
//          cout.flush();

	for (int i = 0; i < 32; i++) {
	    if (module_registrations[i].mask != 0) {
		buf.moveChar(y, ' ', getColor(1), size.x);
		buf.moveString(0, module_registrations[i].name, 0);
//                  buf.moveString(10, module_registrations[i].info, 0);
		if (module_registrations[i].Client) {
		    Module *p =
			((Module *) module_registrations[i].Client);
//                      buf.moveString(10, p->params, 0);
//                      buf.moveString(36, digits(p->errorMask), 0);
		    buf.moveString(36, digits(p->changedMask), 0);
//                      buf.moveString(46, digits(p->handle), 0);
//                      buf.moveString(56, digits(p->PID), 0);
//                      buf.moveString(62, digits(p->execError), 0);
//                      buf.moveString(68, digits(p->execCount), 0);
		}
//                  cout<<registrations[i].name<<endl;
//                  cout.flush();
		writeBuf(0, y, size.x, 1, buf);
		y++;
	    }
	}
	
    }
};


void ViewersHandleEvent(TEvent & event)
{
    TWindow *w;
    TRect r;
    if (event.what == evCommand) {
	switch (event.message.command) {
	case cmViewDrivers:
	    //TView *w = Application->validView(new TWindow());
	    w = new TWindow(TRect(1, 1, 78, 22), "Drivers", 0);
	    if (w != 0) {
		r = w->getExtent();
		r.grow(-1, -1);
		TScrollBar *s =
		    w->standardScrollBar(sbVertical + sbHandleKeyboard);
		w->insert(new DriverView(r, s));
		TProgram::deskTop->insert(w);
	    }
	    break;
	case cmViewRecorders:
	    w = new TWindow(TRect(1, 1, 78, 22), "Modules", 0);
	    if (w != 0) {
		r = w->getExtent();
		r.grow(-1, -1);
		TScrollBar *s =
		    w->standardScrollBar(sbVertical + sbHandleKeyboard);
		w->insert(new ModuleView(r, s));
		TProgram::deskTop->insert(w);
	    }
	    break;
	default:
	    return;
	}
    }

}

/*
    Changes:
    
    05/13/2002  Added viewer for logger modules.
    09/26/2003  Quick adaption to new PLCdrivers.
*/
