/*
 Definition of the VISUAL main program with TURBOVISION based viewer.
 
 Part of VISUAL, a human machine interface and data acquisition program
 
 (C) Thomas Hergenhahn (thomas.hergenhahn@web.de) 2001.

 VISUAL is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 VISUAL is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
*/
#ifndef __visual
#define __visual

class TStatusLine;
class TMenuBar;
class TEvent;
class TPalette;
class fpstream;

class VisualApp:public TApplication {

  public:

    VisualApp(int argc, char **argv);
    static TStatusLine *initStatusLine(TRect r);
    static TMenuBar *initMenuBar(TRect r);
    virtual void handleEvent(TEvent & Event);
    virtual void getEvent(TEvent & event);
    virtual void idle();	// Updates viewers and sleeps to let other threads act

  private:
    void aboutDlgBox();		// "About" box
    void openSheet();		// Open Spreadsheet Viewer
    void tile();		// Tile windows
    void cascade();		// Cascade windows
    void outOfMemory();		// For validView() function
};

#endif /* __visual */
