/*
 The VISUAL main to be used as a daemon.
 
 Part of VISUAL, a human machine interface and data acquisition program
 
 (C) Thomas Hergenhahn (thomas.hergenhahn@web.de) 2001.

 VISUAL is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 VISUAL is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Visual; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  
*/
#include <stdio.h>
#include <unistd.h>

#include "vi_string.h"

#include <pthread.h>

#include "calcthread.h"
#include "loader2.h"
#include "plclog.h"

#define ThisModule "visuald  : "

int main(int argc, char **argv)
{
    time_t t;
    int res;
    LOG2(ThisModule "%d arguments.\n", argc);
    if (argc>1) load2(argv[1]); else load2("visual.cfg");
    time(&t);
    LOG2(ThisModule "%s", ctime(&t));
    LOG1(ThisModule "before creating calculation thread.\n");
    FLUSH;
    pthread_t calculatorHandle;

    res = pthread_create(&calculatorHandle, NULL, calcThread, NULL);
    time(&t);
    LOG3(ThisModule "created calculation thread: %d %s", res, ctime(&t));
    FLUSH;
    while (true) {
	usleep(20000);
    }
    return 0;
}


/*
    Changes:
    
    06/27/2002 	created
    10/04/2003  optionally load other configuration files. Use cnfig file name as the first 
		argument: visual myconfig.
    11/04/2004	fixed position of argument.		
*/
